' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2007, 2008
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
' info required to populate an OSInfo object. For example
' 5.2.3790|Microsoft Windows Server 2003|Service Pack 2|64|3|2600
SUCCESS = 254

Const REG_CSDVERSION = _
    "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\CSDVersion"
            
On Error Resume Next


ObjWMIName = "winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2"
Set objWMIService = GetObject(ObjWMIName)
Set colOperatingSystems = objWMIService.ExecQuery ("Select * from " _
   & "Win32_OperatingSystem")
chkErr()
   
For Each objOperatingSystem in colOperatingSystems
    VERSION = objOperatingSystem.Version
    PRODUCTNAME = objOperatingSystem.Caption
    CSDVERSION = objOperatingSystem.CSDVersion
    BUILD = objOperatingSystem.BuildNumber
Next

If StrComp(CSDVERSION , "") = 0 Then
    ' Newer OS versions seem to not return CSDVERSION
    Set oShell = CreateObject("WScript.shell")
    CSDVERSION = oShell.RegRead(REG_CSDVERSION)
    chkErr()
End If


Set objProc = GetObject("winmgmts:root\cimv2:Win32_Processor='cpu0'")
chkErr()

ARCH_WIDTH = objProc.AddressWidth
ARCH = objProc.Architecture

Wscript.Echo VERSION & "|" & PRODUCTNAME &  "|" & CSDVERSION & "|" &_
      ARCH_WIDTH & "|" & ARCH & "|" & BUILD

' Exit no error
Wscript.Quit(SUCCESS)

Function chkErr
    If Err > 0 Then
        WScript.StdErr.WriteLine Err.number
        WScript.StdErr.WriteLine Err.Description
        Wscript.Quit(0)
    End If    
End Function
