' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2007
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
' info required to populate an OSInfo object. For example
' "5.2.3790|Microsoft Windows Server 2003||64|6"

SUCCESS = 254
BAD_ARG_COUNT = 1
INVALID_KEY = 2
INVALID_PATH = 3
DISK_NOT_AVAIL = 4

On Error Resume Next

Set args = WScript.Arguments
If args.count <> 1 Then
    Wscript.Quit(BAD_ARG_COUNT)    
End If    

path = args.Item(0)

Set fso = CreateObject("Scripting.FileSystemObject")
chkErr

drive = fso.GetDriveName(path)
if drive = "" Then
    Wscript.Quit(INVALID_PATH)
End If

Set d = fso.GetDrive(drive)
' check "disk not ready" or "device unavailable"
if Err = 71 or Err = 68 Then
    Wscript.Quit(DISK_NOT_AVAIL)
End If
chkErr

bytesFree = d.FreeSpace/1024
' check "disk not ready" or "device unavailable"
if Err = 71 or Err = 68 Then
    Wscript.Quit(DISK_NOT_AVAIL)
End If
chkErr

Wscript.echo bytesFree
' Exit no error
Wscript.Quit(SUCCESS)

Function chkErr
    If Err > 0 Then
        WScript.StdErr.WriteLine Err.number
        WScript.StdErr.WriteLine Err.Description
        Wscript.Quit(0)
    End If    
End Function
