' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2007-2008
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
'use WMI to list all subkeys of a given key 
' under HKEY_LOCAL_MACHINE
' Following error exit codes are used:
'      0  abrupt exit (some error occured)
'      1  invalid argument count
'      2  Key specified does not exist
'    254  Success 
'Return values from this script
const SUCCESS = 254
const BAD_ARG_COUNT = 1
const INVALID_KEY = 2
const NO_STD_REG_PROV = 8

On Error Resume Next

Set args = WScript.Arguments
Set oShell = CreateObject("WScript.shell")
chkErr()

If args.count <> 1 Then
    Wscript.Quit(BAD_ARG_COUNT)    
End If    

keyPath = args.Item(0)

const HKLM = &H80000002

Set oShell = WScript.CreateObject("WScript.Shell") 
Set oCtx = CreateObject("WbemScripting.SWbemNamedValueSet")
if oShell.Environment("PROCESS")("PROCESSOR_ARCHITEW6432") <> "" then
oCtx.Add "__ProviderArchitecture", 64
oCtx.Add "__RequiredArchitecture", TRUE
end if

Set oLocator = CreateObject("Wbemscripting.SWbemLocator")
Set oServices = oLocator.ConnectServer("","root\default","","",,,,oCtx)
Set oReg = oServices.Get("StdRegProv") 

if IsEmpty(oReg) Then
    wscript.quit(NO_STD_REG_PROV)
end if
 
rVal = oReg.EnumKey(HKLM, keyPath, arrSubKeys)
chkErr()

If rVal <> 0 Then
    WScript.StdErr.WriteLine "Error reurn code: " & rVal
    If rVal = 5 Then
        WScript.StdErr.WriteLine "Empty keypath"
        Wscript.Quit(SUCCESS)
    ElseIf rVal = 2 Then    
        WScript.StdErr.WriteLine "Invalid keypath"
        Wscript.Quit(INVALID_KEY)
    End if
End If

if IsNull(arrSubKeys) Then
    wscript.quit(SUCCESS)
end if
 
For each subkey in arrSubKeys
    WScript.StdOut.WriteLine subkey
Next
chkErr()

' Exit no error
Wscript.Quit(SUCCESS)

Function chkErr
    If Err > 0 Then
        WScript.StdErr.WriteLine Err.number
        WScript.StdErr.WriteLine Err.Description
        Wscript.Quit(0)
    End If    
End Function