' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2007-2008
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
const SUCCESS = 254
const BAD_ARG_COUNT = 1
const INVALID_KEY = 2
const NO_STD_REG_PROV = 8

const HKLM = &H80000002

On Error Resume Next

Set args = WScript.Arguments
If args.count <> 2 Then
    Wscript.Quit(BAD_ARG_COUNT)    
End If    

keyPath = args.Item(0)

if (UCASE(args.Item(1)) = "RECURSE") then
    recurse = true
else
    recurse = false
end if

Set oShell = WScript.CreateObject("WScript.Shell") 
Set oCtx = CreateObject("WbemScripting.SWbemNamedValueSet")
if oShell.Environment("PROCESS")("PROCESSOR_ARCHITEW6432") <> "" then
oCtx.Add "__ProviderArchitecture", 64
oCtx.Add "__RequiredArchitecture", TRUE
end if

Set oLocator = CreateObject("Wbemscripting.SWbemLocator")
Set oServices = oLocator.ConnectServer("","root\default","","",,,,oCtx)
Set oReg = oServices.Get("StdRegProv") 

if IsEmpty(oReg) Then
    wscript.quit(NO_STD_REG_PROV)
end if

if recurse = false Then
    'check that parent key exists
    lastSlash = InStrRev(keyPath, "\")
    if lastSlash = 0 then
        'no slash so HKLM is parent.
    else
        parentKeyPath = Left(keyPath, lastSlash-1)
        status = oReg.GetStringValue(HKLM, parentKeyPath, "", value)
        if status = 2  Then
            Wscript.Quit(INVALID_KEY)
        elseif status <> 0 and status <> 1 then
            Wscript.Quit(0)
        end If           
    end if        
end if       
status = oReg.CreateKey(HKLM, KeyPath)
chkErr()

If status = 0 Then
    Wscript.Quit(SUCCESS)
Else
    Wscript.Echo "regCreateKey: " & Err.Number
End If

Function chkErr
    If Err > 0 Then
        WScript.StdErr.WriteLine Err.number
        WScript.StdErr.WriteLine Err.Description
        Wscript.Quit(0)
    End If    
End Function