' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp.2007-2008
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
' Given a registry key path, return the keys type and value.  
' Use for listRegistryValueNames and getRegistryValueType
' Two args means give detail on single value. One arg means
'   list all value names/Types under path
const SUCCESS = 254
const BAD_ARG_COUNT = 1
const INVALID_KEY = 2
const INVALID_VALUE_NAME = 6
const INVALID_REG_TYPE = 7
const NO_STD_REG_PROV = 8

const WMI_STATUS_INVALID_KEY_PATH = 2
const WMI_STATUS_INVALID_VALUE_NAME = 1

const HKLM = &H80000002

const REG_SZ = 1
const REG_EXPAND_SZ = 2
const REG_BINARY = 3
const REG_DWORD = 4
const REG_MULTI_SZ = 7

On Error Resume Next
Set args = WScript.Arguments

if args.count <> 5 Then
    Wscript.Quit(BAD_ARG_COUNT)    
End If
   
specifiedType = CInt(args.Item(0))
'wscript.echo "specifiedType " & specifiedType
impliedType = CInt(args.Item(1))
'wscript.echo "impliedType " & impliedType
keyPath = args.Item(2)
'wscript.echo "keyPath " & keyPath
valueName = args.Item(3)
'wscript.echo "valueName " & valueName
' for binary arrays, value is a comma delimited string
value = args.Item(4)
'wscript.echo "value " & value

Set oShell = WScript.CreateObject("WScript.Shell") 
Set oCtx = CreateObject("WbemScripting.SWbemNamedValueSet")
if oShell.Environment("PROCESS")("PROCESSOR_ARCHITEW6432") <> "" then
oCtx.Add "__ProviderArchitecture", 64
oCtx.Add "__RequiredArchitecture", TRUE
end if

Set oLocator = CreateObject("Wbemscripting.SWbemLocator")
Set oServices = oLocator.ConnectServer("","root\default","","",,,,oCtx)
Set oReg = oServices.Get("StdRegProv") 

if IsEmpty(oReg) Then
    wscript.quit(NO_STD_REG_PROV)
end if
     
'wscript.echo "Got stdRegProv"
call chkErr(Err.number, Err.Description)

' determine type to use
if specifiedType = -1 then
    rVal = oReg.EnumValues(HKLM, keyPath, values, types)
    wscript.echo "Enum rVal: " & rVal
    call chkErr(Err.number, Err.Description)
    if rVal <> 0 then
        classfyErrorAndExit(error_num)
    end if     

    matched = False
    targetName = UCase(valueName)
    if not isNull(values) then
        For I=0 To UBound(values)
            keyName = UCase(values(I))
            if targetName = keyName Then
                lookupType =  types(I)
                matched = True
                Exit For
            End if    
        Next
    end if

    if matched AND impliedType = REG_SZ AND lookupType = REG_EXPAND_SZ Then
        regType = REG_EXPAND_SZ
    else     
        regType = impliedType
    End If
Else
     regType = specifiedType       
End if


if ( REG_BINARY = regType ) Then
    arrStr = Split(value, ",")
    status = oReg.SetBinaryValue(HKLM, keyPath, valueName, arrStr)
Elseif ( REG_SZ = regType ) Then
    status = oReg.SetStringValue(HKLM, keyPath, valueName, value)
Elseif ( REG_EXPAND_SZ = regType ) Then
    status = oReg.SetExpandedStringValue(HKLM, keyPath, valueName, value)
Elseif ( REG_DWORD = regType ) Then
    status = oReg.SetDWORDValue(HKLM, keyPath, valueName, value)
Else
    Wscript.Quit(0)            
End If
call chkErr(Err.number, Err.Description)
if status <> 0 then
    classfyErrorAndExit(status)
end if    


if status = 0 then
    wscript.quit(SUCCESS)
else
    wscript.quit(0)
end if

Function classfyErrorAndExit(error_num)
    On Error Resume Next
     
    if error_num = 2 then
        wscript.Quit(INVALID_KEY)
    elseif error_num = 5 then
        wscript.Quit(ACCESS_DENIED)
    else            
        'unknown error
        wscript.echo "Status: " & status
        wscript.Quit(0)    
    end if    
End Function
    
Function chkErr(errNum, errDescript)
    On Error Resume Next
    If errNum > 0 Then
        WScript.StdErr.WriteLine errNum
        WScript.StdErr.WriteLine errDescript
        Wscript.Quit(0)
    End If    
End Function    
